"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var NaturalSort = (function () {
    function NaturalSort() {
    }
    NaturalSort.SORT = function (a, b, insensitive) {
        if (insensitive === void 0) { insensitive = false; }
        var x = NaturalSort.i(a, insensitive);
        var y = NaturalSort.i(b, insensitive);
        var xN = x.replace(NaturalSort.re, '\0$1\0').replace(/\0$/, '').replace(/^\0/, '').split('\0');
        var yN = y.replace(NaturalSort.re, '\0$1\0').replace(/\0$/, '').replace(/^\0/, '').split('\0');
        var xD = parseInt(x.match(NaturalSort.hre), 16) || (xN.length !== 1 && Date.parse(x));
        var yD = parseInt(y.match(NaturalSort.hre), 16) || xD && y.match(NaturalSort.dre) && Date.parse(y) || null;
        if (yD) {
            if (xD < yD) {
                return -1;
            }
            else if (xD > yD) {
                return 1;
            }
        }
        var xNl = xN.length;
        var yNl = yN.length;
        var xyNMax = Math.max(xNl, yNl);
        for (var i = 0; i < xyNMax; i++) {
            var oFxNcL = NaturalSort.normChunk(xN[i] || '', xNl);
            var oFyNcL = NaturalSort.normChunk(yN[i] || '', yNl);
            var oFxNcLS = '' + oFxNcL;
            var oFyNcLS = '' + oFyNcL;
            var oFxNcLSL = oFxNcLS.length;
            var oFyNcLSL = oFyNcLS.length;
            if (oFxNcLSL !== oFyNcLSL && (oFxNcLS[0] === '0' || oFyNcLS[0] === '0')) {
                var max = Math.max(oFxNcLSL, oFyNcLSL);
                oFxNcLS = NaturalSort.fill(oFxNcLS, max);
                oFxNcL = typeof oFxNcL === 'number' ? parseFloat(oFxNcLS) : oFxNcLS;
                oFyNcLS = NaturalSort.fill(oFyNcLS, max);
                oFyNcL = typeof oFyNcLS === 'number' ? parseFloat(oFyNcLS) : oFyNcLS;
            }
            if ((x || '').match(NaturalSort.dot) !== null && (y || '').match(NaturalSort.dot) !== null) {
                return this.dotted(('' + x).split('.'), ('' + y).split('.'));
            }
            if (isNaN(oFxNcL) !== isNaN(oFyNcL)) {
                return isNaN(oFxNcL) ? 1 : -1;
            }
            if (/[^\x00-\x80]/.test(oFxNcL + oFyNcL) && oFxNcL.localeCompare) {
                var comp = oFxNcL.localeCompare(oFyNcL);
                if (comp !== 0) {
                    return comp / Math.abs(comp);
                }
            }
            if (oFxNcL < oFyNcL) {
                return -1;
            }
            else if (oFxNcL > oFyNcL) {
                return 1;
            }
        }
    };
    NaturalSort.dotted = function (a, b) {
        a.reverse();
        b.reverse();
        var count = Math.max(a.length, b.length);
        var result = 0;
        for (var i = 0; i < count; i++) {
            var dx = a[i];
            var dy = b[i];
            if (dx !== dy) {
                if (dx.length !== dy.length && (dx[0] === '0' || dy[0] === '0')) {
                    var max = Math.max(dx.length, dy.length);
                    dx = NaturalSort.fill(dx, max);
                    dy = NaturalSort.fill(dy, max);
                }
                result = parseFloat(dx) < parseFloat(dy) ? -1 : 1;
            }
        }
        return result;
    };
    NaturalSort.fill = function (s, c) {
        for (var i = s.length; i < c; i++) {
            s += '0';
        }
        return s;
    };
    NaturalSort.i = function (s, insensitive) {
        return (insensitive && ('' + s).toLowerCase() || '' + s).replace(NaturalSort.sre, '');
    };
    NaturalSort.normChunk = function (s, l) {
        return (!s.match(NaturalSort.ore) || l == 1) && parseFloat(s) || s.replace(NaturalSort.snre, ' ').replace(NaturalSort.sre, '') || 0;
    };
    NaturalSort.re = /(^([+\-]?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?(?=\D|\s|$))|^0x[\da-fA-F]+$|\d+)/g;
    NaturalSort.sre = /^\s+|\s+$/g;
    NaturalSort.snre = /\s+/g;
    NaturalSort.dre = /(^([\w ]+,?[\w ]+)?[\w ]+,?[\w ]+\d+:\d+(:\d+)?[\w ]?|^\d{1,4}[\/\-]\d{1,4}[\/\-]\d{1,4}|^\w+, \w+ \d+, \d{4})/;
    NaturalSort.hre = /^0x[0-9a-f]+$/i;
    NaturalSort.ore = /^0/;
    NaturalSort.dot = /^\d+(?:\.\d+)+$/;
    return NaturalSort;
}());
exports.NaturalSort = NaturalSort;
//# sourceMappingURL=index.js.map